#!/bin/bash
#

echo "/* This file is auto-generated by configure.sh */" > config.h

TMP="/tmp/test-$$"

file_exists()
{
	echo -n "[*] Checking $1 exists... "
	if [ -f /usr/include/$1 ]; then
		echo "[YES]"
		echo "#define $2 1" >> config.h
	else
		echo "[NO]"
	fi
}

#############################################################################################

echo -n "#define " >> config.h
grep VERSION= Makefile | sed 's/=/ /' >> config.h

#############################################################################################

echo "[*] Checking system headers."

#############################################################################################
# Test 1 : is /usr/include/linux/if_pppox.h new enough to feature pppol2tpin6/pppol2tpv3in6
#
echo -n "[*] Checking if pppox can use pppol2tpin6.. "
rm -f "$TMP" || exit 1

cat >>"$TMP.c" << EOF
#include <stdio.h>
#include <netinet/in.h>
#include <linux/if.h>
#include <linux/if_pppox.h>

void main()
{
	struct sockaddr_pppol2tpin6 *pppox;
	printf("%d\n", pppox->sa_family);
}
EOF

gcc "$TMP.c" -o "$TMP" &>"$TMP.log"

if [ ! -x "$TMP" ]; then
	echo "[NO]"
else
	echo "[YES]"
	echo "#define USE_PPPOL2TPIN6 1" >> config.h
fi

#############################################################################################

file_exists linux/signal.h HAVE_SIGNAL_H

rm -f "$TMP" "$TMP.log" "$TMP.c"

exit 0
